// ************ tether setup **************** //
float tether1[3];
float tether2[3];
0 => int footbutton;

1 => int notDone;
spork ~ getTether();

while (notDone)   {

    30 :: ms => now;
}

//tether input
.98765 => float oldT10;
.98765 => float oldT11;
.98765 => float oldT12;

.98765 => float oldT20;
.98765 => float oldT21;
.98765 => float oldT22;

fun float scaleftoi( float f,  float minv, float maxv )
{
	float i;
	
	// assumption is that f is in range -1.0 to +1.0
	// range is now 0.0 to 2.0
	(((f + 1.0) * ( maxv-minv)) + minv) => i;
	if ( i < minv ) minv => i;
	if ( i > maxv ) maxv => i;
	return i;
}

// basic FM synthesis using sinosc

// modulator to carrier
SinOsc m1 => SinOsc c1  => dac;
SinOsc m2;
SinOsc c2;
//0.7 => g.gain;

// carrier frequency
220 => c1.freq;
// modulator frequency
20 => m1.freq;
// index of modulation
200 => m1.gain;
// phase modulation is FM synthesis (sync is 2)
2 => c1.sync;

// carrier frequency
220 => c2.freq;
// modulator frequency
20 => m2.freq;
// index of modulation
200 => m2.gain;
// phase modulation is FM synthesis (sync is 2)
2 => c2.sync;

fun void getTether()
{    
	// define to 0 to get raw data
	// define to 1 to get integer values 
	1 => int getInts;
	
    Hid hi;
    HidMsg msg;
    0 => int device;

	
	float t10;
	float t11;
	float t12;
	float t20;
	float t21;
	float t22;
	1 => int t10changed;
	1 => int t11changed;
	1 => int t12changed;
	1 => int t20changed;
	1 => int t21changed;
	1 => int t22changed;
	0 => float MINVALUE;
	127 => float MAXVALUE;
	

    if( me.args() ) me.arg(0) => Std.atoi => device;
    if( !hi.openJoystick( device ) ) me.exit();
    <<< "joystick '" + hi.name() + "' ready", "" >>>;
    
    while( notDone )  {

        hi => now;
        while( hi.recv( msg ) )
        {
            if( msg.isAxisMotion() )    // joystick axis motion
            {
                 if	   ( msg.which == 0 ) 
                	msg.axisPosition => tether1[0];
                else if( msg.which == 1 ) 
                	msg.axisPosition => tether1[1];
                else if( msg.which == 2 ) 
                	msg.axisPosition => tether1[2];
                
                else if( msg.which == 3 ) 
                	msg.axisPosition => tether2[0];
                else if( msg.which == 4 ) 
                	msg.axisPosition => tether2[1];
                else if( msg.which == 5 ) 
                	msg.axisPosition => tether2[2];
               
                if ( getInts )
                {
                // raw data is -1.000000 to +1.000000
                // scale to MINVALUE-MAXVALUE
					scaleftoi( tether1[0], MINVALUE, MAXVALUE ) => t10;
					scaleftoi( tether1[1], MINVALUE, MAXVALUE ) => t11;
					scaleftoi( tether1[2], MINVALUE, MAXVALUE ) => t12;

					scaleftoi( tether2[0], MINVALUE, MAXVALUE ) => t20;
					scaleftoi( tether2[1], MINVALUE, MAXVALUE ) => t21;
					scaleftoi( tether2[2], MINVALUE, MAXVALUE ) => t22;
					
					if ( t10 != oldT10 )
					{
						1 => t10changed;
						t10 => oldT10;
					//	t10 => c1.freq;
					}
					if ( t11 != oldT11 )
					{
						1 => t11changed;
						t11 => oldT11;
						//t11 => m1.freq;
					}
					if ( t12 != oldT12 )
					{
						1 => t12changed;
						t12 => oldT12;
					//	t12 => m1.gain;
					}
	
					if ( t20 != oldT20 )
					{
						1 => t20changed;
						t20 => oldT20;
					}
					if ( t21 != oldT21 )
					{
						1 => t21changed;
						t21 => oldT21;
					}
					if ( t22 != oldT22 )
					{
						1 => t22changed;
						t22 => oldT22;
					}
					
					
					if ( t10changed || t11changed || t12changed || t20changed ||t21changed || t22changed )
					{
						<<< t10, t11, t12, t20, t21, t22 >>>;
						0 => t10changed;
						0 => t11changed;
						0 => t12changed;
						0 => t20changed;
						0 => t21changed;
						0 => t22changed;
					}          
                } 
                else // get raw data
                {
                	<<< tether1[0], tether1[1], tether1[2], tether2[0], tether2[1], tether2[2] >>>;
                }
            }
            else if( msg.isButtonDown() )  // joystick button down
            {
                1 => footbutton;
                <<< "foot button", msg.which, "down" >>>;
            }
            
            else if( msg.isButtonUp() )   // joystick button up
            {
                0 => footbutton;
                <<< "foot button", msg.which, "up" >>>;
            }            
        }
    }
}
