// tetherScale
// John Ellinger, Music 208, Spring2013

// ************ tether setup **************** //
float tetherL[3];
float tetherR[3];
0 => int footbutton;
50.0 => float MINFREQ;
5000.0 => float MAXFREQ;

function float getScaledData( float inValue, float outMin, float outMax )
{
	2.0  => float inRange;
	outMax - outMin => float outRange;
	// in value is -1 to + 1
	inValue + 1.0 => inValue; // now its 0 to 2.0
	return (outRange * inValue / inRange) + outMin;
}

fun void getTether()
{    
	Hid hi;
	HidMsg msg;
	0 => int device;
	
	if( me.args() ) me.arg(0) => Std.atoi => device;
	if( !hi.openJoystick( device ) ) me.exit();
	<<< "joystick '" + hi.name() + "' ready", "" >>>;

	while( true )  {
		
		hi => now;
		while( hi.recv( msg ) )
		{
			if( msg.isAxisMotion() )    // joystick axis motion
			{
				if ( msg.which == 0 ) 
					getScaledData( msg.axisPosition, MINFREQ, MAXFREQ ) => tetherL[0];
				else if( msg.which == 1 ) 
					getScaledData( msg.axisPosition, MINFREQ, MAXFREQ ) => tetherL[1];
				else if( msg.which == 2 ) 
					getScaledData( msg.axisPosition, MINFREQ, MAXFREQ ) => tetherL[2];
				
				else if( msg.which == 3 ) 
					getScaledData( msg.axisPosition, MINFREQ, MAXFREQ ) => tetherR[0];
				else if( msg.which == 4 ) 
					getScaledData( msg.axisPosition, MINFREQ, MAXFREQ ) => tetherR[1];
				else if( msg.which == 5 ) 
					getScaledData( msg.axisPosition, MINFREQ, MAXFREQ ) => tetherR[2];
				
				<<< tetherL[0], tetherL[1], tetherL[2], tetherR[0], tetherR[1], tetherR[2] >>>;
				
			}
			else if( msg.isButtonDown() )  // joystick button down
			{
				1 => footbutton;
				<<< "foot button", msg.which, "down" >>>;
			}
			
			else if( msg.isButtonUp() )   // joystick button up
			{
				0 => footbutton;
				<<< "foot button", msg.which, "up" >>>;
			}            
		}
	}
}


spork ~ getTether();

1::hour => now;

